#include <stdio.h>
#include <math.h>
#define MAXPOINTS 7
#define MAXTRIANGLES 26
typedef struct {
	  double x;
	  double y;
 } Point;
typedef struct {
	Point sommets[3];
	double surf;
 } Triangle;

 Point makePoint(double,double);
 int lirePoint(Point*);
 Triangle makeTriangle(Point,Point,Point);
 int lirePoints(Point[], int);
 double determinant(Triangle);
 void affTriangle(Triangle);
 void affTriangles(Triangle[], int);
 double surface(Triangle t);
 void triTriangles(Triangle[],int );

 void main(void) {
	int np, nt;
	int i,j,k;
	Point points[MAXPOINTS];
	Triangle triangles[MAXTRIANGLES];
   Triangle temp;
	np = lirePoints(points,MAXPOINTS);
	nt=0;
	for (i=0; i<np-2;i++)
	  for(j=i+1; j <np-1;j++)
		 for (k=j+1; k<np; k++)
			if (fabs(determinant(temp=makeTriangle(points[i],points[j],points[k])))>1e-7) {
			  temp.surf=surface(temp);
			  triangles[nt++] = temp;
			}

  printf("\n");
  if (nt == 0) printf("On ne peut pas formez des triangles\n");
	else  {
		affTriangles(triangles,nt);
		triTriangles(triangles,nt);
		printf("Apres le tri\n");
		affTriangles(triangles,nt);
	}
 }

 int lirePoint(Point *p){
	int res;
	double x,y;
	res = scanf("%lf%lf",&x,&y);
	if (res == 2) *p = makePoint(x,y);
	return res;
 }

 Point makePoint(double x, double y){
	Point p;
	p.x = x; p.y = y;
	return p;
 }
 int lit_entier_verifie(const int m, const int n){
 int x,y;
 do {
  printf ("Entrez un nombre entre %d et %d: ",m,n);
  y = scanf("%d",&x);
  if (y==EOF) {
     x = -32000;  // erreur
     break;
  }
  if (y!=1) {  // des symbols invalides
     getchar();
     putchar('\n') ;
  }
 }while (y == 0 || x < m || x > n);
 return x ;
}
 int lirePoints(Point p[], int maxn){
	int n=0, i, res;
	printf("Tapez le nombre des points \n");
	n =  lit_entier_verifie(3,maxn);
	printf("Tapez lea coordonnes des points \n");
	for (i=0; i<n; ){
	  printf("Point no %2d: ",i+1);
	  res = lirePoint(p+i);
	  if(res==2) i++;
	}
  return n;
 }

 Triangle makeTriangle(Point p1, Point p2, Point p3){
	Triangle t;
	t.sommets[0] = p1;
	t.sommets[1] = p2;
	t.sommets[2] = p3;
	return t ;
 }

 double determinant(Triangle t){
	double d;
	d = t.sommets[0].x*t.sommets[1].y + t.sommets[1].x*t.sommets[2].y +
		 t.sommets[2].x*t.sommets[0].y - t.sommets[2].x*t.sommets[1].y -
		 t.sommets[1].x*t.sommets[0].y - t.sommets[0].x*t.sommets[2].y;
	return d;
 }
 double surface(Triangle t){
	 return 0.5*fabs(determinant(t));
 }

 void affTriangle(Triangle t){
	int i;
	for (i=0; i<3; i++){
	  printf(" (%6.2lf,%6.2lf),",t.sommets[i].x,t.sommets[i].y);
	}
	printf(" S= %7.3lf", t.surf);
 }

 void affTriangles(Triangle t[], int n){
	 int i;
	 for (i=0; i<n; i++){
		 printf("No %2d : ",i+1);
		 affTriangle(t[i]);
		 putchar('\n');
	 }
 }
/* Effectue le tri d<un tableau de Triangle selon la surface
*/
 void triTriangles(Triangle t[],int n ) {
	Triangle temp;
	int i,j, m;
	for (j = n; j>1; j--){
	  m=0;
	  for (i=1; i<j; i++)
		 if (t[m].surf < t[i].surf) m=i;
	  if (m !=j-1) {
		  temp = t[m];
		  t[m] = t[j-1];
		  t[j-1] = temp;
	  }
	}
 }
